<?php

namespace App\Model;

/**
 * Class Parser
 * @package App\Model
 * @author Artsiom Malkovich (skype: artmalk)
 */
class Parser extends \RedBean_SimpleModel
{

    const STATUS_FINISH = 'Finished';
    const STATUS_WORKING = 'Working';
    const STATUS_PAUSE_FAIL = 'Paused (or Failed)';
    const MAX_NOT_RESPONSE = 300;

    public function getStatus()
    {
        if ($this->bean->finished) {
            $status = self::STATUS_FINISH;
        } else {
            if (time() - $this->update > self::MAX_NOT_RESPONSE) {
                $status = self::STATUS_PAUSE_FAIL;
            } else {
                $status = self::STATUS_WORKING;
            }
        }
        return $status;
    }

    public function getLastUpdate()
    {
        return time() - $this->update;
    }

    public function getParsedCount()
    {
        return count($this->bean->ownBacklinks);
    }

    public function sendNotices()
    {

        if ($this->projects->mail) {
            $removed = $nofollowed = array();
            foreach ($this->projects->ownNotices as $notice) {
                switch ($notice->type) {
                    case 'nofound':
                        $removed[] = $notice->link;
                        break;
                    case 'nofollow':
                        $nofollowed[] = $notice->link;
                        break;
                }
            }

            if ($removed) {
                $removed = implode("\n", $removed);
            } else {
                $removed = 'No removed links, People loves you a lot!';
            }


            if ($nofollowed) {
                $nofollowed = implode("\n", $nofollowed);
            } else {
                $nofollowed = 'No nofollowed links';
            }


            $message = "Hello,\n\nAfter recent update, i have found following changes on which you may want to pay attention.\n\n=== Links REMOVED. ===\n\n" . $removed . "\n\n=== Links NoFollowed. ===\n\n" . $nofollowed . "\n\nPlease note, you're receiving this email from your BLAM software you installed. If you don't want to receive them, then please change settings by logging into your account.\n\nThanks\n\nYour BLAM Software";

            $headers = 'From: ' . $this->projects->mail . "\r\n" .
                'Reply-To: ' . $this->projects->mail . "\r\n";


            mail($this->projects->mail, 'Backlinks Monitoring and Analysis Results.', $message, $headers);
        }

    }
}